Attribute VB_Name = "Declare"
Option Explicit

' Windows declarations
Declare Sub hmemcpy Lib "Kernel" (lpDest As Any, lpSource As Any, ByVal nCount As Long)
'Declare Sub GetWindowRect Lib "Kernel" (ByVal hWnd As Long, rect As MTRECTL)
Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As MTRECTL) As Long
Declare Function InvokeWindowProc Lib "MsgHook.vbx" (ByVal hWnd As Long, ByVal msg As Integer, ByVal wParam As Integer, ByVal lParam As Long) As Long
' Windows constants
Global Const WM_WINDOWPOSCHANGING = &H46
Global Const SWP_NOSIZE = &H1
Global Const SWP_NOMOVE = &H2
Global Const wm_Move = &H3
'Clay's test

' Windows data types
Type WINDOWPOS
    hWnd As Integer
    hwndInsertAfter As Integer
    X As Integer
    Y As Integer
    cx As Integer
    cy As Integer
    flags As Integer
    mutex As Integer
End Type

'''''''''''''''''''''''''''''''''''''''''''''''
' MV-500 const
Global Const MV5_SDK_VERSION = &H100

' Channel constants
Global Const MV5_Channel_Red = 0
Global Const MV5_Channel_Green = 1
Global Const MV5_Channel_Blue = 2
Global Const MV5_Channel_SVideo = 3

' MV-500 Video constants
Global Const MV5_VideoStandard_NTSC = 0
Global Const MV5_VideoStandard_PAL = 1
Global Const MV5_VideoStandard_SECAM = 2
Global Const MV5_VideoStandard_NTSC44 = 3
Global Const MV5_VideoStandard_PALm = 4
Global Const MV5_VideoStandard_PALn = 5
Global Const MV5_VideoStandard_PAL60 = 6
Global Const MV5_VideoStandard_NTSCcomb = 7
Global Const MV5_VideoStandard_SECAMmono = 8
Global Const MV5_VideoStandard_NTSCmono = 9

' MV-500 pixel format constants
Global Const MV5_8bit_Mode = 0
Global Const MV5_RGB332_Mode = 1
Global Const MV5_RGB555_Mode = 2
Global Const MV5_RGB565_Mode = 3
Global Const MV5_RGB888_Mode = 4
Global Const MV5_RGB888x_Mode = 5
Global Const MV5_YUV422_Mode = 6
               
' MV-500 VCR mode constants
Global Const MV5_VCR_Mode_Off = 0
Global Const MV5_VCR_Mode_On = 1

' MV-500 Capture mode constants
Global Const MV5_Grab_Mask = &H1
Global Const MV5_Single_Grab = &H0
Global Const MV5_Cont_Grab = &H1

Global Const MV5_Trigger_Mask = &H6
Global Const MV5_Grab_StartBy_Trigger = &H2
Global Const MV5_Grab_StopBy_Trigger = &H4

Global Const MV5_Grab_Odd = &H0
Global Const MV5_Grab_Even = &H1
Global Const MV5_Grab_Next = &H2

' MV-500 Signal polarity constants
Global Const MV5_Polarity_Mask = &H100
Global Const MV5_Active_Low = 0
Global Const MV5_Active_High = &H100

' MV5InquireBoardInfo constants
Global Const MV5_No_Grab = 0
Global Const MV5_On_Grab = 1

' MV-500 Interrupt flag constants
Global Const MV5_MXfer_DMA1_Int = &H10
Global Const MV5_MXfer_DMA2_Int = &H20
Global Const MV5_MXfer_Int = &H30
Global Const MV5_Video_End_Int = &H40
Global Const MV5_Video_Start_Int = &H80
Global Const MV5_Grab_Int = MV5_Video_Start_Int
Global Const MV5_Video_Frame_Int = &H100
Global Const MV5_OddField_Int = &H200
Global Const MV5_EvenField_Int = &H400
Global Const MV5_Field_Int = &H600
Global Const MV5_Codec_Decoder_Int = &H800
Global Const MV5_Event_Int = &H1000000
Global Const MV5_Trigger_Int = &H2000000
Global Const MV5_Video_FIFO_Underflow_Int = &H40000
Global Const MV5_Video_FIFO_Overflow_Int = &H80000
Global Const MV5_Video_PixelDrop_Int = &H100000

'MV5 error codes
Global Const MV5_OK = 0
Global Const MV5_ERROR = -100
Global Const MV5_PARAM_ERR = -101
Global Const MV5_OPEN_ERR = -102
Global Const MV5_COMPATIBLE_ERR = -103
Global Const MV5_HARDWARE_ERR = -104
Global Const MV5_MEM_ALLOC_ERR = -107
Global Const MV5_NOT_INIT = -108
Global Const MV5_FILE_NOT_EXIST = -109
Global Const MV5_FILE_FORMAT_ERR = -110
Global Const MV5_TOO_MANY_CALLBACK = -111
Global Const MV5_MEM_TOO_BIG = -112
Global Const MV5_STILL_GRAB = -113
Global Const MV5_NOT_GRAB = -114
Global Const MV5_NOT_SUPPORTED = -200

'used by DirectDraw wrapper functions
Global Const PTR_TOP = 1
Global Const PTR_BOTTOM = 0
Global Const N_ADDITIONAL_PAGES = 2

Global Const MV5_NTSC_Width_Default = 640
Global Const MV5_NTSC_Height_Default = 480

' used by MV5InquireBoardInfo()
Type MV5Info
    IRQ As Integer                      ' IRQ assigned to MV-500
    grabState As Integer                ' 1=currently grabbing, 0=not
    Revision As Integer                 ' MV-500 Revision
End Type

' used by MV5 Frame
Type MV5Frame
    f_interlaced As Long
    dummy1 As Long
    dummy2 As Long
    f_sx As Long
    f_sy As Long
    f_width As Long
    f_height As Long
    f_pixel_mode As Long
    f_line_inc As Long              ' stride
    f_magic As Long                 ' for internal control
End Type
Global MyFrame As MV5Frame

' used for MV-500 DMA control
Type MV5DMACONTROL
    tablesize As Long
    pageTable As Long
    pageTablePhyAddr As Long
    pBuffer As Long
    bufSize As Long
End Type

' used for TIFF header information structure
Type MV5TIFFHeaderInfo
    width As Long
    height As Long
    bitspersample As Integer
    samplesperpixel As Integer
    compression As Integer
    rowsperstrip As Long
    photometric As Integer
    H_yuvsubsample As Integer
    V_yuvsubsample As Integer
    yuvposition As Integer
End Type

' display area in terms of pixels
Type MTRECTL
    left As Long
    top As Long
    right As Long
    bottom As Long
End Type

'Used for convenient camera definition
Type CAMERATYPE
    dx As Long
    dy As Long
    ifexist As Long
    frame As MV5Frame
End Type


'
Type MTRGNDATAHEADER
    dwSize As Long
    iType As Long
    nCount As Long
    nRgnSize As Long
    rcBound As MTRECTL
End Type

Type MTRGNDATA
    rdh As MTRGNDATAHEADER
    buffer As String
End Type

Type SIZE
    dx As Long
    dy As Long
End Type

'******************************************
'   1. Board Initialization Group
'******************************************
Declare Function MV5Open Lib "MV5app95.dll" (ByVal SDKVersion As Integer) As Long
Declare Function MV5Close Lib "MV5app95.dll" () As Long
Declare Function MV5Init Lib "MV5app95.dll" () As Long
Declare Function MV5InquireSDKVersion Lib "MV5app95.dll" () As Integer
Declare Function MV5InquireBoardInfo Lib "MV5app95.dll" (MV5BoardInfo As MV5Info) As Long

'******************************************
'   2. Board Control Group
'******************************************
Declare Function MV5SetCurrentBoard Lib "MV5app95.dll" (ByVal BoardID As Integer) As Long
Declare Function MV5GetCurrentBoard Lib "MV5app95.dll" () As Long
Declare Function MV5SetCurrentCamera Lib "MV5app95.dll" (ByVal CameraID As Integer) As Long
Declare Function MV5SetPixelMode Lib "MV5app95.dll" (ByVal pixelMode As Long) As Long
Declare Function MV5GetPixelMode Lib "MV5app95.dll" () As Long
Declare Function MV5SetVCRMode Lib "MV5app95.dll" (ByVal vcrMode As Long) As Long
Declare Function MV5GetVCRMode Lib "MV5app95.dll" () As Long
Declare Function MV5GetPixelSize Lib "MV5app95.dll" () As Long
Declare Function MV5Set2SVideoMode Lib "MV5app95.dll" (ByVal value As Long) As Long

'******************************************
'   3. Look Up Table Group
'******************************************
Declare Function MV5LUTLoad Lib "MV5app95.dll" (ByVal nStart As Long, ByVal nNumber As Long, ByVal value As Any) As Long
Declare Function MV5LUTLoadLinear Lib "MV5app95.dll" () As Long
Declare Function MV5LUTLoadInversedLinear Lib "MV5app95.dll" () As Long

'******************************************
'   4. Video Selection Group
'******************************************
Declare Function MV5SetVideoStandard Lib "MV5app95.dll" (ByVal standard As Integer) As Long
Declare Function MV5GetVideoStandard Lib "MV5app95.dll" (camera As Integer) As Long
Declare Function MV5SetVideoChannel Lib "MV5app95.dll" (ByVal channel As Integer) As Long
Declare Function MV5GetVideoChannel Lib "MV5app95.dll" () As Long
Declare Function MV5LoadDefault Lib "MV5app95.dll" (ByVal standard As Integer) As Long
Declare Function MV5SetBrightness Lib "MV5app95.dll" (ByVal brightness As Long) As Long
Declare Function MV5GetBrightness Lib "MV5app95.dll" () As Long
Declare Function MV5SetContrast Lib "MV5app95.dll" (ByVal contrast As Long) As Long
Declare Function MV5GetContrast Lib "MV5app95.dll" () As Long
Declare Function MV5SetHue Lib "MV5app95.dll" (ByVal hue As Long) As Long
Declare Function MV5GetHue Lib "MV5app95.dll" () As Long
Declare Function MV5SetSaturation Lib "MV5app95.dll" (ByVal saturation As Long) As Long
Declare Function MV5GetSaturation Lib "MV5app95.dll" () As Long
Declare Function MV5SetAGC Lib "MV5app95.dll" (ByVal agcValue As Long) As Long
Declare Function MV5SetScaleFactor Lib "MV5app95.dll" (ByVal HScale As Single, ByVal VScale As Single) As Long
Declare Function MV5GetScaleFactor Lib "MV5app95.dll" (ByVal HScale As Single, ByVal VScale As Single) As Long


'******************************************
'   5. Capture Control Group
'******************************************
Declare Function MV5SetGrabWindow Lib "MV5app95.dll" (ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, frame As MV5Frame) As Long
Declare Function MV5StartGrab Lib "MV5app95.dll" (ByVal mode As Long, ByVal field As Long) As Long
Declare Function MV5StartGrabField Lib "MV5app95.dll" (ByVal mode As Long, ByVal field As Long) As Long
Declare Function MV5StopGrab Lib "MV5app95.dll" (ByVal mode As Any, userData As Any) As Long
Declare Function MV5WaitForVSync Lib "MV5app95.dll" () As Long
Declare Function MV5GetVSyncInfo Lib "MV5app95.dll" () As Long
Declare Function MV5GetFieldInfo Lib "MV5app95.dll" () As Long
Declare Function MV5SetStrobe Lib "MV5app95.dll" (ByVal bit As Long) As Long
Declare Function MV5EnableStrobe Lib "MV5app95.dll" (ByVal flag As Long, ByVal delay As Long, ByVal width As Long, ByVal strobeDoneCallback As Any, ByVal userData As Any) As Long
Declare Function MV5DisableStrobe Lib "MV5app95.dll" () As Long
Declare Function MV5EnableEvent Lib "MV5app95.dll" (ByVal flag As Long, ByVal eventNotifyCallback As Any, ByVal userData As Any) As Long
Declare Function MV5DisableEvent Lib "MV5app95.dll" () As Long
Declare Function MV5ResetEvent Lib "MV5app95.dll" () As Long
Declare Function MV5GenerateEvent Lib "MV5app95.dll" () As Long
Declare Function MV5SetEventPolarity Lib "MV5app95.dll" (ByVal polarity As Long) As Long
Declare Function MV5GetEventPolarity Lib "MV5app95.dll" () As Long
Declare Function MV5EnableTrigger Lib "MV5app95.dll" (ByVal flag As Long, ByVal triggerNotifyCallback As Any, userData As Any) As Long
Declare Function MV5DisableTrigger Lib "MV5app95.dll" () As Long
Declare Function MV5ResetTrigger Lib "MV5app95.dll" () As Long
Declare Function MV5GenerateTrigger Lib "MV5app95.dll" () As Long
Declare Function MV5SetTriggerPolarity Lib "MV5app95.dll" (ByVal polarity As Long) As Long
Declare Function MV5GetTriggerPolarity Lib "MV5app95.dll" () As Long

'******************************************
'   6. Memory Access Group
'******************************************
Declare Function MV5UnlockMasterBuffer Lib "MV5app95.dll" (ByRef buffer As Any, ByVal SIZE As Long) As Long
Declare Function MV5LockMasterBuffer Lib "MV5app95.dll" (ByRef buffer As Any, ByVal SIZE As Long) As Long

'******************************************
'   7. File I/O Group
'******************************************
Declare Function MV5InquireBMPVals Lib "MV5app95.dll" (ByVal name As String, ByRef px As Any, ByRef py As Any, ByRef bp As Any) As Long
Declare Function MV5BMPfile2Memory Lib "MV5app95.dll" (ByVal name As String, ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, ByVal length As Long, ByVal pixelFormat As Long, ByRef buffer As Any) As Long
Declare Function MV5BMPfile2MemoryDIB Lib "MV5app95.dll" (ByVal name As String, ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, ByVal length As Long, ByVal pixelFormat As Long, ByRef buffer As Any) As Long
Declare Function MV5Memory2BMPfile Lib "MV5app95.dll" (ByVal name As String, ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, ByVal length As Long, ByVal pixelFormat As Long, ByRef buffer As Any) As Long
Declare Function MV5InquireTIFFVals Lib "MV5app95.dll" (ByVal name As String, ByRef px As Any, ByRef py As Any, ByRef bp As Any) As Long
Declare Function MV5TIFFfile2Memory Lib "MV5app95.dll" (ByVal name As String, ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, ByVal length As Long, ByVal pixelFormat As Long, ByRef buffer As Any) As Long
Declare Function MV5TIFFfile2MemoryDIB Lib "MV5app95.dll" (ByVal name As String, ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, ByVal length As Long, ByVal pixelFormat As Long, ByRef buffer As Any) As Long
Declare Function MV5Memory2TIFFfile Lib "MV5app95.dll" (ByVal name As String, ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, ByVal length As Long, ByVal pixelFormat As Long, ByRef buffer As Any) As Long
Declare Function MV5InquireTGAVals Lib "MV5app95.dll" (ByVal name As String, ByRef px As Any, ByRef py As Any, ByRef bp As Any) As Long
'Declare Function MV5TGALoad Lib "MV5app95.dll" (ByVal name As String, ByVal sx As Long, ByVal sy As Long, ByVal dsx As Long, ByVal dsy As Long, ByVal dx As Long, ByVal dy As Long, ByVal flag As Long) As Long
'Declare Function MV5TGASave Lib "MV5app95.dll" (ByVal name As String, ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, ByVal flag As Long) As Long
'Declare Function MV5InquireTIFFVals Lib "MV5app95.dll" (ByVal name As String, dx As Long, dy As Long, fmt As Long) As Long
'Declare Function MV5TIFFLoad Lib "MV5app95.dll" (ByVal name As String, ByVal sx As Long, ByVal sy As Long, ByVal dsx As Long, ByVal dsy As Long, ByVal dx As Long, ByVal dy As Long, ByVal flag As Long) As Long
'Declare Function MV5TIFFSave Lib "MV5app95.dll" (ByVal name As String, ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, ByVal flag As Long) As Long

'**********************************************
'   8. Interrupt Handling Group
'**********************************************
Declare Function MV5ConnectInterruptToCallback Lib "MV5app95.dll" (ByVal BoardID As Long, ByVal Callback As Any, ByVal IRQMode As Long, userData As Any) As Long
Declare Function MV5DisconnectInterruptToCallback Lib "MV5app95.dll" (ByVal BoardID As Long, ByVal Callback As Any, ByVal IRQMode As Long) As Long

'**********************************************
'   9. DMA Access
'**********************************************
Declare Function MV5SetMasterModeTransfer Lib "MV5app95.dll" (ByRef frame As MV5Frame, ByVal buffer As Any, ByVal mem_size As Long, ByVal stride As Long) As Long
Declare Function MV5SetMasterModeTransferMemory Lib "MV5app95.dll" Alias "MV5SetMasterModeTransfer" (ByRef frame As MV5Frame, ByRef buffer As Any, ByVal mem_size As Long, ByVal stride As Long) As Long

Declare Function MV5SetMasterModeTransferField Lib "MV5app95.dll" (ByRef frame As MV5Frame, ByRef buffer As Any, ByVal mem_size As Long, ByVal stride As Long, ByVal order As Long) As Long
Declare Function MV5GetMasterModeTransferControl Lib "MV5app95.dll" (ByVal index As Long, ByVal pControl As Any) As Long
Declare Function MV5SetMasterModeTransferControl Lib "MV5app95.dll" (ByVal index As Long, ByVal pControl As Any) As Long

'**********************************************
'   10. Color Conversion Access
'**********************************************
Declare Function MV5Yuv2RGB888xCCIR601_422 Lib "MV5app95.dll" (ByRef inbuffer As Any, ByRef outbuffer As Any, ByVal length As Long) As Long
Declare Function MV5Yuv2RGB888CCIR601_422 Lib "MV5app95.dll" (ByRef inbuffer As Any, ByRef outbuffer As Any, ByVal length As Long) As Long
Declare Function MV5Yuv2RGB555CCIR601_422 Lib "MV5app95.dll" (ByRef inbuffer As Any, ByRef outbuffer As Any, ByVal length As Long) As Long

'**********************************************
'   11. DirectDraw Wrapper functions
'**********************************************
Declare Function MTDDraw_Open Lib "MV5app95.dll" (ByVal xWnd As Long, ByVal bvar As Long) As Long

Declare Function MTDDraw_Close Lib "MV5app95.dll" () As Long
Declare Function MTDDraw_GetBitsPerPixel Lib "MV5app95.dll" () As Long
Declare Function MTDDraw_GetScreenMode Lib "MV5app95.dll" () As Long
Declare Function MTDDraw_GetScreenSize Lib "MV5app95.dll" () As SIZE
Declare Function MTDDraw_IsOverlaySupported Lib "MV5app95.dll" () As Long

'Declare Function MTDDraw_GetOverlayStretchRange Lib "MV5app95.dll" (ByVal nMinStretch As Double, ByVal nMaxStretch As Double) As Long
Declare Function MTDDraw_CreateOverlayYUV Lib "MV5app95.dll" (ByVal nSurfaces As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal nFormatID As Long, pIndexes As Long) As Long
Declare Function MTDDraw_DestroyOverlayYUV Lib "MV5app95.dll" (ByVal nIndex As Long) As Long
Declare Function MTDDraw_GetSurfaceMemoryPtr Lib "MV5app95.dll" (ByVal nSurfaceIndex As Long, nSurfaceLineOffset As Long) As Long
Declare Function MTDDraw_SetDestColorKey Lib "MV5app95.dll" (ByVal dwColorKey As Long) As Long
Declare Function MTDDraw_SetSrcColorKey Lib "MV5app95.dll" (ByVal nSurface As Long, ByVal dwColorKeyLow As Long, ByVal dwColorKeyHigh As Long) As Long
Declare Function MTDDraw_MapSurfaceRect Lib "MV5app95.dll" (ByVal nSurfaceIndex As Long, ByRef pDestRect As MTRECTL, ByRef pSrcRect As MTRECTL, ByVal bForceOverlay As Boolean) As Long
Declare Function MTDDraw_GetPrimarySurfaceParams Lib "MV5app95.dll" (ByRef rect As MTRECTL, nIntegerCount As Long, nStrideCount As Long, nLineCount As Long, ppPtr As Long, ByVal bIsTop As Long) As Long
Declare Function MTDDraw_OpenVIP Lib "MV5app95.dll" () As Long
Declare Function MTDDraw_CloseVIP Lib "MV5app95.dll" () As Long
Declare Function MTDDraw_InitVIP Lib "MV5app95.dll" (ByVal nFormatID As Long, ByVal dwWidth As Long, ByVal dwHeight As Long) As Long
Declare Function MTDDraw_UninitVIP Lib "MV5app95.dll" () As Long
Declare Function MTDDraw_VIPStartVideo Lib "MV5app95.dll" (ByVal dwWidth As Long, ByVal dwHeight As Long) As Long
Declare Function MTDDraw_VIPStopVideo Lib "MV5app95.dll" () As Long
Declare Function MTDDraw_VIPShow Lib "MV5app95.dll" (ByRef pSrcRect As MTRECTL, ByRef pDestRect As MTRECTL) As Long
Declare Function MTDDraw_VIPHide Lib "MV5app95.dll" () As Long

Global GrabFlag As Boolean
Global problem As Integer
Global ImgDxOld As Integer
Global ImgDyOld As Integer
Global ImgDx As Long
Global ImgDy As Long

Global Const Hoffset = &H33
Global Const Voffset = &HA

Global SDKVersion As Integer

Global GrabWndWidth As Long
Global GrabWndHeight As Long
Global HScaleFactor As Long
Global VScaleFactor As Long
Global HZoomFactor As Long
Global VZoomFactor As Long
Global FrameModeFlag As Boolean
Global OverlayFactor As Integer
Global PicOverlayTop As Integer
Global PicOverlayleft As Integer
Global PicOverlayWidth As Integer
Global PicOverlayHeight As Integer
Global PicOverlayColor As Long
Global ShpFrameTop As Integer
Global ShpFrameleft As Integer
Global ShpFrameWidth As Integer
Global ShpFrameHeight As Integer
Global ShpFrameColor As Long
Global PicBallTop As Integer
Global PicBallLeft As Integer
Global PicBallWidth As Integer
Global PicBallHeight As Integer
Global PicBallColor As Long
Global LblTitleTop As Integer
Global LblTitleLeft As Integer
Global LblTitleWidth As Integer
Global LblTitleHeight As Integer
Global LblTitleColor As Long
Global LblTitleFontSize As Integer
Global ShpBallWidth As Integer
Global ShpBallHeight As Integer

Global UpDefault As Integer, DownDefault As Integer
Global LeftDefault As Integer, RightDefault As Integer
Global UpCurrent As Integer, DownCurrent As Integer
Global LeftCurrent As Integer, RightCurrent As Integer
Global i As Integer
Global dx As Integer, dy As Integer
Global Const step = 1
Global ExitFlag As Boolean
Global Load2 As Boolean
Global m_ScreenSize As SIZE
Global m_nScreenMode As Long
Global CamCurrent As CAMERATYPE
Global m_nSurfaceIndex As Long
Global result As Long
Global nMaxStretch As Single
Global nMinStretch As Single
Global m_nSurfaceStride As Long
Global m_lpOverlaySurfacePtr As Long
Global dwColorKey As Long
Global bvar As Long
Global memsize As Long
Global stride As Long
Global MYbuffer(1 To 640, 1 To 480) As Integer
Global srect As MTRECTL
Global drect As MTRECTL
Global sync As Long

Public Sub Ret_Err(ret As Long)
If (ret = MV5_OK) Then Exit Sub
If (ret = MV5_ERROR) Then MsgBox ("MV5_ERROR")
If (ret = MV5_PARAM_ERR) Then MsgBox ("MV5_PARAM_ERR")
If (ret = MV5_OPEN_ERR) Then MsgBox ("MV5_OPEN_ERR")
If (ret = MV5_COMPATIBLE_ERR) Then MsgBox ("MV5_COMPATIBLE_ERR")
If (ret = MV5_MEM_ALLOC_ERR) Then MsgBox ("MEM_ALLOC_ERR")
If (ret = MV5_NOT_INIT) Then MsgBox ("MV5_NOT_INIT")
If (ret = MV5_FILE_NOT_EXIST) Then MsgBox ("MV5_FILE_NOT_EXIST")
If (ret = MV5_FILE_FORMAT_ERR) Then MsgBox ("MV5_FILE_FORMAT_ERR")
If (ret = MV5_TOO_MANY_CALLBACK) Then MsgBox ("MV5_TOO_MANY_CALLBACK")
If (ret = MV5_MEM_TOO_BIG) Then MsgBox ("MV5_MEM_TOO_BIG")
If (ret = MV5_STILL_GRAB) Then MsgBox ("MV5_STILL_GRAB")
If (ret = MV5_NOT_GRAB) Then MsgBox ("MV5_NOT_GRAB")
If (ret = MV5_NOT_SUPPORTED) Then MsgBox ("MV5_NOT_SUPPORTED")
End Sub

Public Function MV5Memory2TIFFfileDIB(ByVal filename As String, ByVal sx As Long, ByVal sy As Long, ByVal dx As Long, ByVal dy As Long, ByVal stride As Long, ByVal mode As Long, ByRef buffer() As Integer) As Long

    Dim row, col As Integer
    Dim bufout(1 To 640, 1 To 480) As Integer
    
    For row = 1 To 480
        For col = 1 To 640
            bufout(col, (481 - row)) = buffer(col, row)
        Next col
    Next row
    
    Ret_Err (MV5Memory2TIFFfile(filename, sx, sy, dx, dy, stride, mode, bufout(1, 1)))
End Function


